#!/bin/bash

# mkdir -p /opt/docker-run/all && curl -o /opt/docker-run/all/all.sh https://git.zykeji.club/open/server-init/raw/master/Docker/run/all.sh && sh /opt/docker-run/all/all.sh

read -r -p "是否安装Redis?(y/n)" isRedis

if [ $isRedis = "y" ]; then
echo "开始安装Redis"

read -r -p "请输入Redis版本(默认: latest): " redisVersion
redisVersion=${redisVersion:-latest}

read -r -p "请输入容器名称(默认: redis): " redisName
redisName=${redisName:-redis}

read -r -p "请输入外部访问端口号(默认: 6379): " redisPort
redisPort=${redisPort:-6379}

read -r -p "请输入绑定的IP地址(默认: 0.0.0.0): " redisHost
redisHost=${redisHost:-"0.0.0.0"}

read -r -p "请输入密码(默认: 123456): " redisPassword
redisPassword=${redisPassword:-"123456"}

echo "创建脚本存放目录和数据"
mkdir -p /opt/docker-run/$redisName/data
mkdir -p /opt/docker-run/$redisName/conf

echo "创建Redis配置文件"
touch /opt/docker-run/$redisName/conf/redis.conf
echo "清空旧配置"
cat /dev/null > /opt/docker-run/$redisName/conf/redis.conf
echo "写入新配置"
cat <<EOF >> /opt/docker-run/$redisName/conf/redis.conf
bind $redisHost
daemonize NO
protected-mode no
requirepass $redisPassword
EOF

echo "拉取镜像"
docker pull redis:$redisVersion
echo "运行容器"
echo "run -d --name $redisName -p $redisPort:6379 -v /opt/docker-run/$redisName/data:/data -v /opt/docker-run/$redisName/conf/redis.conf:/etc/redis/redis.conf redis:$redisVersion redis-server /etc/redis/redis.conf --appendonly yes"
docker run -d --name $redisName -p $redisPort:6379 -v /opt/docker-run/$redisName/data:/data -v /opt/docker-run/$redisName/conf/redis.conf:/etc/redis/redis.conf redis:$redisVersion redis-server /etc/redis/redis.conf --appendonly yes

echo "脚本执行完成"

fi
